/**
 *
 *
  _____                      _              _ _ _     _   _     _        __ _ _
 |  __ \                    | |            | (_) |   | | | |   (_)      / _(_) |
 | |  | | ___    _ __   ___ | |_    ___  __| |_| |_  | |_| |__  _ ___  | |_ _| | ___
 | |  | |/ _ \  | '_ \ / _ \| __|  / _ \/ _` | | __| | __| '_ \| / __| |  _| | |/ _ \
 | |__| | (_) | | | | | (_) | |_  |  __/ (_| | | |_  | |_| | | | \__ \ | | | | |  __/
 |_____/ \___/  |_| |_|\___/ \__|  \___|\__,_|_|\__|  \__|_| |_|_|___/ |_| |_|_|\___|

 * DO NOT EDIT THIS FILE!!
 *
 *  FOR CUSTOMIZE ParametroBaseService PLEASE EDIT ../Parametro.service.ts
 *
 *  -- THIS FILE WILL BE OVERWRITTEN ON THE NEXT SKAFFOLDER'S CODE GENERATION --
 *
 */
// DEPENDENCIES
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { HttpClient, } from '@angular/common/http';

// CONFIG
import { environment } from '../../../environments/environment';
import { Parametro } from 'src/app/domain/gifloadmin_db/parametro';

// MODEL

/**
 * THIS SERVICE MAKE HTTP REQUEST TO SERVER, FOR CUSTOMIZE IT EDIT ../Parametro.service.ts
 */

/*
 * SCHEMA DB Parametro
 *
    {
        activo: {
            type: 'String'
        },
        codigo: {
            type: 'String'
        },
        fotoNombre: {
            type: 'String'
        },
        grupo: {
            type: 'String'
        },
        nombre: {
            type: 'String'
        },
        orden: {
            type: 'Integer'
        },
        //RELATIONS
        //EXTERNAL RELATIONS
    }
 *
 */

@Injectable()
export class ParametroBaseService {

  contextUrl: string = environment.endpoint + '/system/parametro';
  constructor(
    protected http: HttpClient
  ) { }

  // CRUD METHODS

  /**
  * ParametroService.create
  *   @description CRUD ACTION create
  *   @param Parametro obj Object to insert
  *
  */
  create(item: Parametro): Observable<Parametro> {
    return this.http
      .post<Parametro>(this.contextUrl, item)
      .pipe(map(data => data));
  }

  /**
  * ParametroService.delete
  *   @description CRUD ACTION delete
  *   @param ObjectId id Id Parametro
  *
  */
  remove(id: string): Observable<void> {
    return this.http
      .delete<void>(this.contextUrl + '/' + id)
      .pipe(map(data => data));
  }

  /**
  * ParametroService.get
  *   @description CRUD ACTION get
  *   @param ObjectId id Id Parametro
  *   @returns Parametro
  *
  */
  get(id: string): Observable<Parametro> {
    return this.http
      .get<Parametro>(this.contextUrl + '/' + id)
      .pipe(map(data => data));
  }

  /**
  * ParametroService.list
  *   @description CRUD ACTION list
  *   @returns ARRAY OF Parametro
  *
  */
  list(): Observable<any> {
    return this.http
      .get<any>(this.contextUrl, { params: { 'page': 0, 'size': 500 } }).pipe(map(data => data['_embedded']['parametroes']));
  }

  /**
  * ParametroService.update
  *   @description CRUD ACTION update
  *   @param ObjectId id Id Parametro
  *   @returns Parametro
  *
  */
  update(item: Parametro): Observable<Parametro> {
    return this.http
      .put<Parametro>(this.contextUrl + '/' + item.id, item)
      .pipe(map(data => data));
  }


  // Custom APIs

}
